<?php
/**
 *  Flash Accel Management Console (FMC)
 *  Copyright (C) 2013, NetApp, Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Javascript
 *
 *    Farbtastic - Copyright (c) 2010 Matt Farina
 *
 *    jQuery - Copyright (c) 2010 John Resig
 * 
 *    jQuery BBQ - Copyright (c) 2010 "Cowboy" Ben Alman
 *  
 *    jQuery Cookie - Copyright (c) 2006 Klaus Hartl
 *  
 *    jQuery Form - Copyright (c) 2010 Mike Alsup
 *  
 *    jQuery Once - Copyright (c) 2009 Konstantin K\ufffdfer
 *
 *    jQuery UI - Copyright (c) 2010 by the original authors
 *      (http://jqueryui.com/about)
 *
 *    Sizzle.js - Copyright (c) 2010 The Dojo Foundation (http://sizzlejs.com/)
 *
 *  PHP
 *
 *    ArchiveTar - Copyright (c) 1997 - 2008 Vincent Blavet
 */

/**
 *  Generate vcenterdiscoverd.pl command to obtain hostinfo for given host.
 */
function mercury_management_wcmd_hostinfo($host_name)
{
  return "hostinfo\n$host_name\n";
}


/**
 *  Generate vcenterdiscoverd.pl command to obtain vminfo for given vm.
 */
function mercury_management_wcmd_vminfo($vm)
{
  return "vminfo\n$vm\n";
}


/**
 *  Generate vcenterdiscoverd.pl command to obtain vdiskinfo for given vm.
 */
function mercury_management_wcmd_vdiskinfo($vm)
{
  return "vdiskinfo\n$vm\n";
}


/**
 *  Generate vcenterdiscoverd.pl command to obtain host FA VIB status for given host.
 */
function mercury_management_wcmd_host_fa_vib_status($host_name, $host_username, $host_password)
{
  return "host_fa_vib_status\n$host_name\n$host_username\n$host_password\n";
}


/**
 *  Generate vcenterdiscoverd.pl command to initate host adapter rescan.
 */
function mercury_management_wcmd_rescan_adapter($vc_hostname, $vc_username, $vc_password, $host_name, $adapter)
{
  $str  = "/usr/bin/esxcli"
        . " -s $vc_hostname"
        . " --username '" . $vc_username . "'"
        . " --password '" . $vc_password . "'"
        . " -h '"         . $host_name   . "'"
        . " storage core adapter rescan"
        . " --adapter '"  . $adapter     . "'"
        ;
  return "exec\n$str\n";
}


/**
 *  Generate vcenterdiscoverd.pl command to obtain list of orphaned cache spaces.
 */
function mercury_management_wcmd_get_orphans($vc_hostname, $vc_username, $vc_password, $host_name)
{
  $str  = "/usr/bin/perl /usr/lib/vmware-vcli/apps/host/rdmDisk.pl"
        . " --url https://" . $vc_hostname . "/sdk/vimService"
        . " --username '" . $vc_username ."'"
        . " --password '" . $vc_password ."'"
        . " --hostname '" . $host_name   ."'"
        . " --operation getOrphanedCacheSpaces"
        ;
  return "exec\n$str\n";
}


/**
 *  Generate vcenterdiscoverd.pl command to obtain host_control.py 1 data.
 */
function mercury_management_wcmd_host_control_1($host_name, $host_username, $host_password)
{
  $str  = "/usr/lib/vmware-vcli/apps/host/host_control.py"
        . " '" . $host_name     . "'"
        . " '" . $host_username . "'"
        . " '" . $host_password . "'"
        . " 1"
        ;
  return "exec\n$str\n";
}


/**
 *  Generate vcenterdiscoverd.pl command to obtain host device list.
 */
function mercury_management_wcmd_esxcli_device_list($vc_hostname, $vc_username, $vc_password, $host_name)
{
  $str  = "/usr/bin/esxcli"
        . " -s $vc_hostname"
        . " --username '" . $vc_username . "'"
        . " --password '" . $vc_password . "'"
        . " -h '"         . $host_name   . "'"
        . " storage core device list"
        ;
  return "exec\n$str\n";
}


/**
 *  Generate vcenterdiscoverd.pl command to obtain host path list.
 */
function mercury_management_wcmd_esxcli_path_list($vc_hostname, $vc_username, $vc_password, $host_name)
{
  $str  = "/usr/bin/esxcli"
        . " -s $vc_hostname"
        . " --username '" . $vc_username . "'"
        . " --password '" . $vc_password . "'"
        . " -h '"         . $host_name   . "'"
        . " storage core path list"
        ;
  return "exec\n$str\n";
}

/**
 *  Generate vcenterdiscoverd.pl command to obtain system coredump partition list.
 *  Example output:
 *  ~ # esxcli system coredump partition list
 *  Name                    Path                                        Active  Configured
 *  ----------------------  ------------------------------------------  ------  ----------
 *  mpx.vmhba32:C0:T0:L0:7  /vmfs/devices/disks/mpx.vmhba32:C0:T0:L0:7    true        true
 */
function mercury_management_wcmd_esxcli_system_coredump_partition_list($vc_hostname, $vc_username, $vc_password, $host_name)
{
  $str  = "/usr/bin/esxcli"
        . " -s $vc_hostname"
        . " --username '" . $vc_username . "'"
        . " --password '" . $vc_password . "'"
        . " -h '"         . $host_name   . "'"
        . " system coredump partition list"
        ;
  return "exec\n$str\n";
}
/**
 *  Generate vcenterdiscoverd.pl command to check VM credentials.
 */
function mercury_management_wcmd_vmrun_chk_cred($vc_hostname, $vc_username, $vc_password, $username, $password, $path)
{
  $str = "/usr/bin/vmrun -T esx"
       . " -h https://" . $vc_hostname . "/sdk"
       . " -u '" . $vc_username . "'"
       . " -p '" . $vc_password . "'"
       . " -gu '" . $username . "'"
       . " -gp '" . $password . "'"
       . " fileExistsInGuest '" . $path . "' \"C:\Windows\explorer.exe\"";
  return "exec\n$str\n";
}


/**
 *  Generate vcenterdiscoverd.pl command to check if FA is installed on VM.
 */
function mercury_management_wcmd_vmrun_chk_for_fa($vc_hostname, $vc_username, $vc_password, $username, $password, $path)
{
  $str = "/usr/bin/vmrun -T esx"
       . " -h https://" . $vc_hostname . "/sdk"
       . " -u '" . $vc_username . "'"
       . " -p '" . $vc_password . "'"
       . " -gu '" . $username . "'"
       . " -gp '" . $password . "'"
       . " fileExistsInGuest '" . $path . "'".' "C:\Program Files\NetApp\FlashAccel\FA-Service\FA-Service.dll"';
  return "exec\n$str\n";
}


/**
 *  Generate vcenterdiscoverd.pl command to submit a webservice command to a VM.
 */
function mercury_management_wcmd_mm_wsdl($hostname, $username, $password, $method, $param = NULL, $port = NULL)
{
  $str = "/usr/bin/php /var/www/mercury/sites/all/modules/custom/mercury_management/mm_wsdl.php"
       . " --hostname '" . $hostname . "'"
       . " --username '" . $username . "'"
       . " --password '" . $password . "'"
       . " --method '"   . $method   . "'";   
  if (isset($param)) {
    $str .= " --param '" . $param . "'";
  }
  if (isset($port)) {
    $str .= " --port '" . $port . "'";
  }
  return "exec\n$str\n";
}


/**
 *  Generate vcenterdiscoverd.pl command to validate a FQDN.
 */
function mercury_management_wcmd_validate_fqdn($hostname)
{
  $hostparts = explode('.', $hostname);
  $str = "/usr/bin/host " . $hostparts[0];
  return "exec\n$str\n";
}


/**
 *  Generate vcenterdiscoverd.pl command to determine vCenter version.
 */
function mercury_management_wcmd_vcenter_version()
{
  return "vcversion\n";
}


/**
 *  Generate vcenterdiscoverd.pl command to obtain list of datacenters
 */
function mercury_management_wcmd_dclist()
{
  return "dclist\n";
}


/**
 *  Generate vcenterdiscoverd.pl command to obtain list of hosts in a datacenter
 */
function mercury_management_wcmd_hostlist_dc($dc)
{
  return "hostlist_dc\n$dc\n";
}


/**
 *  Generate vcenterdiscoverd.pl command to obtain list of hosts and VMs in a 
 *  datacenter
 */
function mercury_management_wcmd_vmlist_dc($dc)
{
  return "vmlist_dc\n$dc\n";
}


/**
 *  Parse hostinfo output.
 */
function mercury_management_parse_hostinfo($result)
{
  $host_info_with_key = array();
  if (!empty($result)) {
    foreach ($result as $value) {
      $val_split = explode(':', $value);
      if (count($val_split) > 1) {
        $key = $val_split[0];
        $host_info_with_key[$key] = trim($val_split[1]);
      }
    }
  }
  
  return $host_info_with_key;
}


/**
 *  Parse vminfo output.
 */
function mercury_management_parse_vminfo($result)
{
  $vm_info_with_key = array();
  
  if (!empty($result)) {
    foreach ($result as $value) {
      $val_split = explode(':', $value);
      if (count($val_split) > 1) {
        $key = $val_split[0];
        $vm_info_with_key[$key] = trim($val_split[1]);
      }
    }
  }
  
  return $vm_info_with_key;
}


/**
 *  Parse vdiskinfo output.
 */
function mercury_management_parse_vdiskinfo($vmname, $dataArr)
{
  $vdiskArr = array();

  if (!empty($dataArr)) {
    foreach ($dataArr as $value) {
      if (!stristr($value, "Disk")) {
        continue;
      }
      $val_split = explode(':', $value);
      if (trim($val_split[1]) == "Not Known") {
        return $vdiskArr;
      }
      
      // Sample output (note possible spaces and odd characters in VM name):
      // ab-_()+, =.cd Disk[0]: Name : Hard disk 1
      // ab-_()+, =.cd Disk[0]: Type : VMDK
      // ab-_()+, =.cd Disk[0]: Id : naa.6000C2b17f5442b5bcaf0f022c84bc4e
      // ab-_()+, =.cd Disk[0]: Capacity : 85899345920
      // ab-_()+, =.cd Disk[0]: Path : Not Known
      // ab-_()+, =.cd Disk[0]: Freespace : Not Known

      $n = sscanf($value, "$vmname Disk[%[0-9]]: %s : %[^\n]", $disk, $f_name, $f_val);
      
      if ($n != 3) {
        continue;
      }
      
      $f_val = trim($f_val);
      switch ($f_name) {
      case "Path":
        $vdiskArr[$disk]['Path'] = $f_val;
        break;
      case "Name":
        $vdiskArr[$disk]['name'] = $f_val;
        break;
      case "Type":
        $vdiskArr[$disk]['type'] = $f_val;
        break;
      case "Freespace":
        $vdiskArr[$disk]['freespace'] = $f_val;
        break;
      case "Capacity":
        $vdiskArr[$disk]['Capacity'] = $f_val;
        break;
      case "Blocks":
	$vdiskArr[$disk]['Blocks'] = $f_val;
	break;
      case "Blocksize":
	$vdiskArr[$disk]['Blocksize'] = $f_val;
	break;
      case "Id":
        $vdiskArr[$disk]['id'] = $f_val;
        break;
      }
    }
  }
  
  return $vdiskArr;
}


/**
 *  Parse output of rdmDisk.pl getOrphanedCacheSpaces.
 */
function mercury_management_parse_orphaned_cache_spaces($result)
{
  $orphanedCacheSpaces = array();
  
  foreach ($result as $output_line) {
    if (!empty($output_line) && stristr($output_line, "Error")) {
      return $output_line;
    } 
    if (!empty($output_line) && stristr($output_line, "NAAID:")) {
      $orphanedCacheSpaceIDArray = explode(':',$output_line);
      if (count($orphanedCacheSpaceIDArray) > 1) {
        array_push($orphanedCacheSpaces, trim($orphanedCacheSpaceIDArray[1]));
      }
    }
  }
  
  return $orphanedCacheSpaces;
}


/**
 *  Parse output of host_control.py 1
 */
function mercury_management_parse_host_control_1($result)
{
  $host_info_with_key = array();
  
  foreach ($result as $value) {
    $val_split = explode(':', $value);
    if (count($val_split) > 1) {
      $key = $val_split[0];
      if ($key == 'HBTL') {
	$hbtl_split = explode('HBTL:', $value);
	$host_info_with_key[$key] = trim($hbtl_split[1]);
      } else {
	$host_info_with_key[$key] = trim($val_split[1]);
      }
    }
  }

  return $host_info_with_key;
}


/**
 *  Parse ESX host device and path lists.
 */
function mercury_management_parse_esx_device_and_path_lists($dataArr, $dataPathArr, $diagnosticPartitions)
{
  $deviceArr = array();
  if (empty($dataArr)) {
    return $deviceArr;
  }
  $validTransportDevices = array();
  $diagnosticDevices = array();

  /** Devices configured with a diagnostic partition shouldn't be displayed
   * Example output
   * ~ # esxcli system coredump partition list
   * Name                    Path                                        Active  Configured
   * ----------------------  ------------------------------------------  ------  ----------
   * mpx.vmhba32:C0:T0:L0:7  /vmfs/devices/disks/mpx.vmhba32:C0:T0:L0:7    true        true
   */
  foreach ($diagnosticPartitions as $outputLine) {
    if (!empty($outputLine) && stristr($outputLine, 'Error')) {
      break;
    }

    $deviceWithPartitionArr = explode(' ', $outputLine);
    $deviceWithPartition = $deviceWithPartitionArr[0];

    $diagnosticDeviceArr = explode(':', $deviceWithPartition);
    $diagnosticDevice = $diagnosticDeviceArr[0];
    $diagnosticDevices[$diagnosticDevice] = 1;
  }
   

  foreach ($dataPathArr as $outputLine) {
    $matches = array();

    # Looking for lines starting with 0 or more spaces, then Device:
    if (preg_match('/^ *Device: +(.+)$/', $outputLine, $matches)) {
      $device_name = trim($matches[1]);

    # Looking for lines starting with 0 or more spaces, then Transport:
    } else if (preg_match('/^ *Transport: +(.+)$/', $outputLine, $matches)) {
      $transport_type = trim($matches[1]);
      if (isset($device_name) &&
          ($device_name != '') &&
          ($device_name != 'No associated device') &&
          ($device_name != 'Runtime error') && 
          ($transport_type != 'usb') &&
          ($transport_type != 'ide') &&
          ($transport_type != 'block') &&
          ($transport_type != 'sata')) {
        $validTransportDevices[$device_name] = 1;
        unset($device_name);
      }
    }
  }

  $validDeviceFlag = 0;
  foreach ($dataArr as $value) {

    # Looking for non-empty lines with no leading spaces
    if (preg_match('/(^[^ ].*)$/', $value, $matches)) {
      $serial = trim($matches[1]);
      if ($validTransportDevices[$serial] == 1) {
        $deviceArr[$serial]['serial_no'] = $serial;
        $validDeviceFlag = 1;
# Stubbing this due to the decision to unfix burt 704093.  For now I want
# to make it really easy to add this back in.  If you delete this code,
# please also remove the related code above, the $diagnosticPartitions
# parameter, and fix the places that call here -- deriving that parameter
# adds an extra, now unnecessary step to host discovery/refresh.
#        if (!empty($diagnosticDevices[$serial])) {
#          if ($diagnosticDevices[$serial] == 1) {
#            unset($deviceArr[$serial]);
#            $validDeviceFlag = 0;
#          }
#        }
      } else {
        $validDeviceFlag = 0;
      }
    } else if ($validDeviceFlag == 1) {
      
      # Looking for lines that start with three spaces, then <Key>:, then
      # 0 or more spaces, then 0 or more non-space characters that we will
      # use as the value associated with <Key>.
      if (preg_match('/^   ([^:]+): *(.*)$/', $value, $matches)) {
        $key = $matches[1];
        $val = trim($matches[2]);
        $deviceArr[$serial][$key] = $val;
      } else {
        $validDeviceFlag = 0;
      }
    }
  }
  
  return $deviceArr;
}


/**
 *  Parse output of vmrun for checking VM credentials.
 */
function mercury_management_parse_vmrun_chk_cred($result)
{
  foreach ($result as $output) {
    if (!empty($output) && stristr($output, 'Error')) {
      if (stristr($output, 'password')) {
        return "Error";
      } else {
        return "CannotConnect";
      }
    }
  }
  
  return "Success";
}


/**
 *  Parse output of vmrun for checking for FA installed.
 */
function mercury_management_parse_vmrun_chk_for_fa($result)
{
  $driver_status = "Agent Not Installed";

  foreach ($result as $output) {
    if (!empty($output) && stristr($output, 'The file exists.')) {
      $driver_status = "Agent Installed";
    }
  }
  
  return $driver_status;
}


/**
 *  Parse output of host for validating FQDN.
 */
function mercury_management_parse_wcmd_validate_fqdn($result, &$ip)
{
  if (empty($result)) {
    return false;
  }

  foreach ($result as $output) {
    if (stristr($output, 'has address')) {
      $parts = explode(' ', $output);
      $ip = $parts[3];
      return true;
    }
  }

  return false;
}


/**
 *  Parse output of vcd command vmlist_dc
 */
function mercury_management_parse_wcmd_vmlist_dc($result)
{
   $rv = array();
   
   $count = 0;
   foreach ($result as $output_line) {
      $exploded = explode(':', $output_line);
      $type = strtolower(trim(array_shift($exploded)));
      $name = trim(implode(':', $exploded));
      if ($type == 'host' || $type == 'vm') {
         $rv[$count]['type'] = $type;
         $rv[$count]['name'] = $name;
         $count++;
      }
   }
   
   return $rv;
}
